//////////////////////////////////////////////////////////////////////////////////////////
function add_shadow
{
	your.shadow = 0;
	if(opt_shadow == 2)
	{
		your.shadow = 1;
	}
	if(opt_shadow == 1 && your.ent_type > 0)
	{
		your.shadow = 1;
	}
	if(your.transparent == 1 || your.invisible == 1)
	{
		your.shadow = 0;
	}
}
function add_shader
{
	your.material = mat_model;
	if(opt_shader == 1)
	{
		your.material = mtl_specular;
	}
}
function count_objects
{
	mice_level = 0;
	hackers_level = 0;
	boxes_level = 0;
	
	mice_eaten = 0;
	hackers_eaten = 0;
	boxes_destroyed = 0;
	you = ent_next(null);
	while(you != null)
	{
		add_shadow();
		add_shader();
		if(your.ent_type == type_mouse){mice_level+=1;}
		if(your.ent_type == type_hacker){hackers_level+=1;}
		if(your.ent_type == type_box){boxes_level+=1;}
		you = ent_next(you);
	}
}
function game_win
{
	on_esc = null;
	game_active = 0;
	wait(-1);
	str_cpy(game_over_str,"Congratulations!\nyou Won");
	game_over.visible = on;
	wait(-2);
	level_load("");
	if(menus.visible == 1){return;}
	game_over.visible = off;
	if(level_current == 0){str_cpy(after_str,"something weird happened....\n how did you get here?");}
	if(level_current == 1){str_cpy(after_str,win1);}
	if(level_current == 2){str_cpy(after_str,win2);}
	if(level_current == 3){str_cpy(after_str,win3);}
	if(level_current == 4){str_cpy(after_str,win4);}
	if(level_current == 5){str_cpy(after_str,win5);}
	if(level_current == 6){str_cpy(after_str,win6);}
	if(level_current == 7){str_cpy(after_str,win7);}
	if(level_current == 8){game_end();return;}
	level_opened+=1;
	display_after();
	play_menu_music();
}
function game_lose
{
	on_esc = null;
	wait(-1);
	str_cpy(game_over_str,"Game over\nyou lost!");
	game_over.visible = on;
	game_active = 0;
	wait(-2);
	level_load("");
	if(menus.visible == 1){return;}
	game_over.visible = off;
	if(level_current == 0){str_cpy(after_str,"something weird happened....\n how did you get here?");}
	if(level_current == 1){str_cpy(after_str,lose1);}
	if(level_current == 2){str_cpy(after_str,lose2);}
	if(level_current == 3){str_cpy(after_str,lose3);}
	if(level_current == 4){str_cpy(after_str,lose4);}
	if(level_current == 5){str_cpy(after_str,lose5);}
	if(level_current == 6){str_cpy(after_str,lose6);}
	if(level_current == 7){str_cpy(after_str,lose7);}
	if(level_current == 8){str_cpy(after_str,lose8);}
	display_after();
	play_menu_music();
}
function game_run
{
	while(!player){wait(1);}
	while(1)
	{
		mice_panel = mice_level-mice_eaten;
		hackers_panel = hackers_level-hackers_eaten;
		boxes_panel = boxes_level-boxes_destroyed;
		
		if(mice_eaten == mice_level 
		&& hackers_eaten == hackers_level)
		{
			game_win();
			return;
		}
		if(boxes_destroyed == boxes_level
		|| !player)
		{
			game_lose();
			return;
		}
		time_played+=1;
		wait(-1);
		if(menus.visible == 1){return;}
	}
	game_lose();
}
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
function play_game_music
{
	if(media_playing(music_handle) == 1)
	{
		media_stop(music_handle);
	}
	result = int(random(5));
	if(result == 0){music_handle = media_play(game1_mus,0,50);}
	if(result == 1){music_handle = media_play(game2_mus,0,50);}
	if(result == 2){music_handle = media_play(game3_mus,0,50);}
	if(result == 3){music_handle = media_play(game4_mus,0,50);}
	if(result == 4){music_handle = media_play(game5_mus,0,50);}
	
	while(media_playing(music_handle) == 1)
	{
		wait(1);
	}
}
function play_menu_music
{
	if(media_playing(music_handle) == 1)
	{
		media_stop(music_handle);
	}
	music_handle = media_loop(menu_mus,0,100);
}
//////////////////////////////////////////////////////////////////////////////////////////
function game_init
{
	wait(2);
	game_active = 0;
	sky_color.red = 1;
	sky_color.green = 1;
	sky_color.blue = 1;
	hide_menus();
	camera_intro();
	game_start.visible = on;
	play_game_music();
	count_objects();
	wait(-2);
	while(key_any == 0)
	{
		wait(1);
	}
	game_start.visible = off;
	game_active = 1;
	game_hud.visible = on;
	on_esc = show_ingame;//place a pause menu here
	game_run();
}
//////////////////////////////////////////////////////////////////////////////////////////
function load_level_1
{
	if(level_opened < 1){return;}
	level_color = color_orange;
	level_current = 1;
	tail_empty();
	str_cpy(levelname_str,"the firewall");
	level_load("level1.wmb");
	wait(2);
	display_mission();
}
function load_level_2
{
	if(level_opened < 2){return;}
	level_color = color_green;
	level_current = 2;
	tail_empty();
	str_cpy(levelname_str,"Root Directory");
	level_load("level2.wmb");
	wait(2);
	display_mission();
}
function load_level_3
{
	if(level_opened < 3){return;}
	level_color = color_red;
	level_current = 3;
	tail_empty();
	str_cpy(levelname_str,"B.O.S.");
	level_load("level3.wmb");
	wait(2);
	display_mission();
}
function load_level_4
{
	if(level_opened < 4){return;}
	level_color = color_orange;
	level_current = 4;
	tail_empty();
	str_cpy(levelname_str,"the server");
	level_load("level4.wmb");
	wait(2);
	display_mission();
}
function load_level_5
{
	if(level_opened < 5){return;}
	level_color = color_blue;
	level_current = 5;
	tail_empty();
	str_cpy(levelname_str,"the website");
	level_load("level5.wmb");
	wait(2);
	display_mission();
}
function load_level_6
{
	if(level_opened < 6){return;}
	level_color = color_red;
	level_current = 6;
	tail_empty();
	str_cpy(levelname_str,"the downloads");
	level_load("level6.wmb");
	wait(2);
	display_mission();
}
function load_level_7
{
	if(level_opened < 7){return;}
	level_color = color_orange;
	level_current = 7;
	tail_empty();
	str_cpy(levelname_str,"website graphics");
	level_load("level7.wmb");
	wait(2);
	display_mission();
}
function load_level_8
{
	if(level_opened < 8){return;}
	level_color = color_blue;
	level_current = 8;
	tail_empty();
	str_cpy(levelname_str,"antivirus");
	level_load("level8.wmb");
	wait(2);
	display_mission();
}